#include "seg.h"
#include "seg_global.h"
    

/*********************************************************/
/*    ML segmentation of each layer*/
/***********************************************************/
void ML_Test(struct BigPyramid* Pyramid, struct ModelPar *Par, char *outfn) 
{
  struct Par_GMM *GMM_par ;
  struct Par_QTR *QTr_par ;
  unsigned char ***SegPt ;
  int D, nClasses, nRow,nCol, i,m,i1,j1, status ;
  char fname[80] ;
  FILE *outfd ;
  double max_ll ;
  int max_index ;
  double ***ll;      /* log likehood at each pixel of the multispectral images*/
  
  GMM_par = &(Par->GMM_par) ;
  QTr_par = &(Par->QTr_par) ;
  D = Pyramid->level ;
  nClasses = QTr_par->nclasses ;
  SegPt = Pyramid->_Segment ;
  
  if(vlevel>3) printf("\tsegmenting the image by maximal likelihood\n");
  for(i=0; i<D; i++) {
    if((GMM_par->existSig)[i]) {
        nRow = (Pyramid->nRow)[i] ;
        nCol = (Pyramid->nCol)[i] ;
    	SegPt[i]=(unsigned char**) get_img(nCol,nRow,sizeof(unsigned char));
    	ll = (Pyramid->LProb)[i] ;

    	for(i1=0; i1<nRow; i1++) 
    	for(j1=0; j1<nCol; j1++) {
            /* Maximal likelihood alg  */
            max_ll = ll[i1][j1][0] ; 
            max_index = 0 ;
            for(m=1; m<nClasses; m++) {
            	if(max_ll<ll[i1][j1][m]) {
                	max_ll=ll[i1][j1][m] ; 
                	max_index = m ;
            	}
        	}
        	SegPt[i][i1][j1]=(unsigned char) (max_index) ;
    	}
    
        sprintf(fname,"%s.s%d.ML",outfn,i) ;
        if( ! write_segmentation(SegPt[i], nRow, nCol, fname) ) { 
             fprintf(stderr,"ERROR: Cannot write %s, exit ML_Test\n",fname);
             exit (-10);
        }            
      
        if(vlevel >=3) printf("\t\t%s is written out ...\n",fname) ;
    }
  }
  if(vlevel>3) printf("\tfinish ML()\n") ;
}
  
  
  
