#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

static void outofmemory()
{
    fprintf (stderr, "Out Of Memory\n");
    exit(-1);
}


char *G_malloc(int n)
{
    char *b;

    b = malloc((unsigned)n);
    if (b) return(b);
    outofmemory();
}

char *G_calloc(int n, int m)
{
    char *b;

    b = calloc((unsigned)n,(unsigned)m);
    if (b) return(b);
    outofmemory();
}

char *G_realloc(char *b, int n)
{
    if (b == NULL) b = malloc ((unsigned)n);
    else b = realloc(b, (unsigned)n);
    if (b) return(b);
    outofmemory();
}


double *G_alloc_vector(int n)
{
    return (double *) G_calloc (n, sizeof(double));
}


double **G_alloc_matrix(int rows, int cols)
{
    double **m;
    int i;

    m = (double **) G_calloc (rows, sizeof(double *));
    m[0] = (double *) G_calloc (rows*cols, sizeof(double));
    for (i = 1; i < rows; i++)
	m[i] = m[i-1] + cols;
    return m;
}


void G_free_vector(double *v)
{
    free ((char *)v);
}


void G_free_matrix(double **m)
{
    free ((char *)(m[0]));
    free ((char *)m);
}


int *G_alloc_ivector(int n)
{
    return (int *) G_calloc (n, sizeof(int));
}


int **G_alloc_imatrix(int rows, int cols)
{
    int **m;
    int i;

    m = (int **) G_calloc (rows, sizeof(int *));
    m[0] = (int *) G_calloc (rows*cols, sizeof(int));
    for (i = 1; i < rows; i++)
	m[i] = m[i-1] + cols;
    return m;
}


void G_free_ivector(int *v)
{
    free ((char *)v);
}



void G_free_imatrix(int **m)
{
    free ((char *)(m[0]));
    free ((char *)m);
}
