#include <stdio.h>
#include "sig.h"
/* prototypes*/
void *mget_spc(int num,size_t size);
/*end of prototypes*/

struct ClassSig *I_NewClassSig (struct SigSet *S)
{
    struct ClassSig *Sp;
    if (S->nclasses == 0)
        S->ClassSig = (struct ClassSig *) mget_spc (1,sizeof(struct ClassSig));
    else
        S->ClassSig = (struct ClassSig *) G_realloc ((char *)S->ClassSig,
		sizeof(struct ClassSig) * (S->nclasses+1));

    Sp = &S->ClassSig[S->nclasses++];
    Sp->classnum = 0;
    Sp->nsubclasses = 0;
    Sp->used = 1;
    Sp->type = SIGNATURE_TYPE_MIXED;
    Sp->title = NULL;
    return Sp;
}


struct SubSig *
I_NewSubSig (struct SigSet *S, struct ClassSig *C)
{
    struct SubSig *Sp;
    int i;

    if (C->nsubclasses == 0)
        C->SubSig = (struct SubSig *) G_malloc (sizeof(struct SubSig));
    else
        C->SubSig = (struct SubSig *) G_realloc ((char *)C->SubSig,
		sizeof(struct SubSig) * (C->nsubclasses+1));

    Sp = &C->SubSig[C->nsubclasses++];
    Sp->used = 1;
    Sp->R = (double **) G_calloc (S->nbands, sizeof(double *));
    Sp->R[0] = (double *) G_calloc (S->nbands * S->nbands, sizeof(double));
    for (i = 1; i < S->nbands; i++)
	Sp->R[i] = Sp->R[i-1] + S->nbands;
    Sp->Rinv = (double **) G_calloc (S->nbands, sizeof(double *));
    Sp->Rinv[0] = (double *) G_calloc (S->nbands * S->nbands, sizeof(double));
    for (i = 1; i < S->nbands; i++)
	Sp->Rinv[i] = Sp->Rinv[i-1] + S->nbands;
    Sp->means = (double *) G_calloc (S->nbands, sizeof(double));
    Sp->N = 0;
    Sp->pi = 0;
    Sp->cnst = 0;
    return Sp;
}
