#ifndef SIG_H
#define SIG_H

struct SigSet
{
    int nbands;
    int nclasses;
    char *title;
    struct ClassSig
    {
	    long classnum;
        char *title;
        int used;
	    int type;
        int nsubclasses;
        struct SubSig
        {
            double N;
	        double pi;
            double *means;
            double **R;
            double **Rinv;
	        double cnst;
            int used;
        } *SubSig;
        
        struct ClassData
        {
	    	int npixels;
	    	double **x;   /* pixel list: x[npixels][nbands] */
	    	double **p;   /* prob        p[npixels][subclasses] */
        } ClassData;
    } *ClassSig;
};

#define SIGNATURE_TYPE_MIXED 1

extern char *G_malloc(int n) ;
extern char *G_calloc(int n, int m);
extern char *G_realloc(char *b, int n);

/* io_sig.c */

void I_WriteSigSet(FILE *fd, struct SigSet *S) ;
void I_ReadSigSet (FILE *fd, struct SigSet *S) ;
void I_TermSigSet(struct SigSet *S) ;
char *I_GetClassTitle (struct ClassSig *C) ;
char *I_GetSigTitle (struct SigSet *S) ;

/* new.c */
struct ClassSig *I_NewClassSig (struct SigSet *S);
struct SubSig *I_NewSubSig (struct SigSet *S, struct ClassSig *C);



#endif  /* SIG_H */
