#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <ctype.h>

#include "tiffio.h"
#include "tiffImg.h"
#include "color.h"

#define SHOW 1 
#define SILENT 0 

void error(char *name);

int main (int argc, char **argv) 
{
  TIFF_img *input_img;
  int i,j, nrow, ncol ;
  char des_type ;
  
    
  if ( argc != 5 ) error( argv[0] );

  printf("reading input image %s\n", argv[1] ) ;
  input_img = Read_TIFF_Img(argv[1], SHOW) ;
  if ( input_img == NULL ) {
    fprintf ( stderr, "error reading file %s\n", argv[1] );
    exit(1);
  }
  
  printf("input image type %c\n", input_img->TIFF_type ) ;
  sscanf(argv[3], "%c", &des_type) ;
  printf("Output image type %c\n", des_type) ;

  TIFF_Color_Transform(input_img, des_type) ;
  
  printf("Output image compress %s\n", argv[4]) ;
  sprintf(input_img->compress_type, argv[4]) ;
  if ( ! Write_TIFF_Img(argv[2], input_img, argv[1]) ) {
    fprintf ( stderr, "error writting file %s\n", argv[2] );
    exit(1);
  }


byebye:
  /* de-allocate space which was used for the images */
  if( input_img != NULL ) Free_TIFF ( input_img );
}


void error(char *name)
{
    printf("usage:  %s  infile.tiff  outfile.tiff  color_space  compress_type\n",name);
    exit(1);
}

