#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include "TreeStruct.h"
#include "../../utilities/src/util.h"
#include "../../segment/src/seg.h"


#define MIN_SAMPELS_PER_NODE 10
#define MIN_COST_CHANGE      0.000000001
#define MAX_CPT_SAMPLES      180000
#define MAX_CPT_LEAVES       200



/* TrPrune.c */

void TreePruning(FILE *fd, struct TreeNode *x, int depth) ;
void construct_CPT(struct Trees *treePt) ;


/* TrEntropy.c */

void entropyEntpDrop(int *YY, struct TreeNode *node, int nClasses,
    int RangeF, int Show) ;
double entropy(int *YY, int n0, int n1, int nClasses, int RangeF) ;
void PrintHistPrior(double **Hist, double *Prior, int nClasses, int RangeF) ;


/* TrFeatBin.c */

void FeatBinCor(int *Y, int **X, int nL, int nH, int nNeighb, int nClasses,
   double **corXX, double **corXY, int Show );
void FeatBinarized(int *X, int nNeighb, int nClasses, int *bX);


/* TrGrow.c */

void DecTreeInitial( struct TreeNode **root, int nL, int nH, struct Tree_Info
    *treeInfoPt ) ;
int ConstructDecTree( struct Trees *treePt, int iChild); /*return nleaves used*/
int growTree(struct Trees *treePt, int nN0, int nN1, int iChild) ;
void FreeNodeBelow(struct TreeNode* node) ;

/* TrLinearSplit.c */

int LinearSplit(struct TreeNode *node, struct Tree_Data *DataPt, 
    struct Tree_Info *treeInfoPt, int iChild) ;


/* TrPartition.c */

int localPartition(int *XX, struct TreeNode *node, int nNeighb, int nClasses) ;
int Partition(struct TreeNode *node, int iChild, struct Tree_Info *treeInfoPt, 
    struct Tree_Data *DataPt) ;
void testPartitionOnly(struct TreeNode *node, int iChild,
    struct Tree_Info *treeInfoPt, struct Tree_Data *DataPt ) ;


/* pinv.c */

int pinv(double **a, int m, int n, double **b, int ChangeIndex);
  /* a=input, b=output matrices */
  /* m, n -- number of row, col */
  /* If ChangeIndex>0, change index. Index starts from 1 instead of from 0 */


/* stat.c */

void Covariance( double **x, int m, int n, /* n_row, n_col */
    double **Cov,  double *Mean) ;



/* TrUtil.c */

void showTreeEntropy(FILE *fd, struct TreeNode *x, int depth) ;
void showTreeSampleSize(FILE *fd, struct TreeNode *x, int nSamplesTotal, 
    int depth) ;
void showTreeHistogram(FILE *fd, struct TreeNode *x, int nClasses, int depth) ;
void ShowCurrentResult(struct TreeNode *root, struct Tree_Info *treeInfoPt,
    struct Tree_Data *DataPt) ;





/* CPT_MAP.c */

void sampleMAP_NO_OPT( 
  struct BigPyramid* Pyramid,
  struct ModelPar *Par,
  char *outfn,
  int outputLevel
) ;
void InitialDataWeight(struct ModelPar *Par, char *fn, double dataWeight) ;


/* CPT_util.c */

double CalculateRndRatio(int N,  char **hs_fn, int nFiles) ;
void InitializeCPT( struct CP_Trees *CPT ) ;
void AllocateCPT_Data( struct Trees *treePt, int N ) ;
void FreeCPT_Data( struct Trees *treePt ) ;
int extract_samples_CPT( struct ModelPar *ParPt, int nFiles, char **org_fn,
    char **hs_fn, int Level, double RndRatio, int N, char *otfn, 
    float thr_match ) ;
int extract_groundtruth_CPT( struct ModelPar *ParPt, int nFiles, 
    char **hs_fn, int Level, double RndRatio, int N, char *otfn ) ;




 
