#include "../../utilities/src/util.h"
#include "../../segment/src/seg.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

/******************************************************************************/
/* GMM model parameters */
/******************************************************************************/
#ifndef  GMM_DEF
#define  GMM_DEF

struct Par_GMM
{
    char feature_name[128] ;
    int  dimen ;
    int  nclasses ;
    int  nFiles ;
    int  MaxLevels ;	 /* Max level of features needed, or allowed */
    int  Rt ;	         /* subsampling rate when extracting features */

    int  *existSig ;	     /* =1, if a signature exists at that level */ 
    struct SigSet *_Sig ;    /* signature at a level */
  
    void (*GenerateFunc)();  /* Generating Function */
} ;
#endif  /* GMM_DEF */



/* SampG_u.c */
void SaveFeature(
  struct BigPyramid* Pyramid, 
  eisl_img* imgPt, 	/* input images */
  struct Par_GMM *GMM_par,   
  char   *otfn ,
  double **Rate,
  int    **count,
  double Noise_Std 
) ;


/* u_pyramid.c */

void GMM_ConstructPyramid (int nrow, int ncol, 
         struct BigPyramid *bigPyramid, int DD) ;
void GMM_free_bigPyramid (struct BigPyramid *bigPyramid) ;

