/* rountines for calculate mean, cov ...
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* Calculate the covariance matrix,  each row is an observation */
void Covariance(
  double **x, 
  int m, int n,   /* n_row, n_col */
  double **Cov, 
  double *Mean
)
{
  int i,j,k ;
  
  if(m==1) {
  	fprintf(stdout, "Only 1 sample, can not estimate cov\n") ;
  	return ;
  }
  
  for(i=0; i<n; i++) {
  	Mean[i]=0.0 ;
  	for(j=i; j<n; j++) Cov[i][j]=Cov[j][i]=0 ;
  }
  
  for(k=0; k<m; k++) {	/* for each sample */
  	for(i=0; i<n; i++) {
  		Mean[i] += x[k][i] ;
  		for(j=0; j<n; j++) {
  			Cov[i][j] += x[k][i] * x[k][j] ;
  		}
  	}
  }
  
  for(i=0; i<n; i++) {
  	for(j=0; j<n; j++) {
  		Cov[i][j] = (Cov[i][j] - Mean[i] * Mean[j]/m)/(m-1) ;
  	}
  }
  
  for(i=0; i<n; i++) Mean[i] /= m ;


}
