/*  1-D, 2-D convolution subrountines   
    
    writen by Hui Cheng,		2/29/1996
*/

#include "allocate.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void Conv1() ;
void Conv2() ;

/*  main program to show how to use Conv1() and Conv2() 
main()
{
  int i,j ;
  double x[3], y[4], **xx, **yy ;
  double *z, **zz ;
  int s1,s2, z1,z2 ;
  
  x[0]=1; x[1]=2; x[2]=3;
  y[0]=1; y[1]=-1; y[2]=5; y[3]=6 ;
  Conv1(x,3,0,y,4,2,&z,&s1,&z1) ;
  printf("size = %d, zero = %d\n",s1,z1) ;
  for(i=0; i<s1; i++) printf("%lf  ",z[i]) ;
  printf("\n\n") ;
  
  xx=(double**) get_img(2,2,sizeof(double)) ;
  yy=(double**) get_img(1,3,sizeof(double)) ;
  yy[0][0] = 1; yy[0][1] = 2 ; yy[0][2] = 3 ;
  xx[0][0] = 0 ; 	xx[0][1] = 1 ; 
  xx[1][0] = 2 ;	xx[1][1] = 3 ;
  Conv2(xx,2,2,1,1,yy,1,3,0,0,&zz,&s1,&s2,&z1,&z2) ;
  printf("size = %d,%d,  zero = %d, %d \n",s1,s2,z1,z2) ;
  for(i=0; i<s1; i++) {
  	for(j=0; j<s2; j++) printf("%lf  ",zz[i][j]) ;
  	printf("\n") ;
  }
  
}
*/

/* 1-D convolution of two arbitrary vectors */
void Conv1(v1,size1,zero1, v2,size2,zero2, out,sizePt,zeroPt)
  double *v1, *v2 ;  	/* input vectors */
  double **out ;	/* output vectore */
  int size1, size2, *sizePt ;	
  int zero1, zero2, *zeroPt ; 	/* the index of origin, index
  				   start from 0 */
{
  int k ;
  int i1,i2 ;
  int size_out ;
  double temp ;
  
  size_out = size1+size2-1 ;
  (*out) = (double*) get_spc(size_out,sizeof(double)) ;
  
  for(k=0; k<size_out; k++) {
  	temp = 0 ;
  	for(i1=0; i1<size1; i1++) {
  		i2 = k-i1 ;
  		if((i2>=0) && (i2<size2)) {
  			temp += v1[i1] * v2[i2] ;
  		} 
  	}
  	(*out)[k] = temp ;
  }
  
  (*sizePt) = size_out ;
  (*zeroPt) = zero1+zero2 ;
   
}


/* 2-D convolution of two arbitrary vectors */
void Conv2(m1,row1,col1,z11,z12,m2,row2,col2,z21,z22,out,rowPt,colPt,z1Pt,z2Pt)
  double **m1, **m2 ;  	/* input matricess */
  double ***out ;		/* output matrix */
  int row1, row2, *rowPt, col1, col2, *colPt ;	
  int z11, z12, z21, z22, *z1Pt, *z2Pt ; 	/* the index of origin, index
  				   		start from 0 */
{
  int i,j ;
  int r1,r2, c1,c2 ;
  int row_out, col_out ;
  double temp ;

  row_out = row1+row2-1 ;
  col_out = col1+col2-1 ;
  (*out) = (double**) get_img(col_out,row_out,sizeof(double)) ;

  for(i=0; i<row_out; i++) 
  for(j=0; j<col_out; j++) {
  	temp = 0 ;
  	for(r1=0; r1<row1; r1++) 
  	for(c1=0; c1<col1; c1++) {
  		r2 = i-r1 ;	c2 = j-c1 ;
  		if((r2>=0) && (r2<row2) && (c2>=0) && (c2<col2)) {
  			temp += m1[r1][c1] * m2[r2][c2] ;
  		} 
  	}
  	(*out)[i][j] = temp ;
  }
  
  (*rowPt) = row_out ;	(*colPt) = col_out ;
  (*z1Pt) = z11+z21 ;	(*z2Pt) = z12+z22 ;
   
}
